module ckp(
	clk,
	rst,
	trig0,
	trig1,
	trig2,
	trig3,
	tx_rs232);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst;
	input trig0;
	input trig1;
	input trig2;
	input trig3;
	output tx_rs232;

	wire clk;
	wire rst;
	wire trig0;
	wire trig1;
	wire trig2;
	wire trig3;
	wire tx_rs232;

	//----Code starts here: integrated by Robei-----
	
	
	
	wire [7:0] data_byte;
		wire done;
		wire start;
		wire [3:0]trig;
		wire pos_en;
		
		reg en1;
		reg [31:0] cnt1;
		reg en;
		reg u_en;
		reg [7:0] u_data_byte;
		reg u_start;
		reg [3:0]u_trig;
		reg [3:0]stay;
		reg con;
		reg control;
		reg [3:0] data_cnt;
		
	assign trig	= {trig3,trig2,trig1,trig0};
	uart_tx_ckp u_uart_tx(
		.clk(clk),
		.rst(rst),
		.data_byte(data_byte),
		.start(start),
		.tx_rs232(tx_rs232),
		.done(done)
	    );
		
	assign 	data_byte = u_data_byte;
	assign 	start = u_start;
	assign 	pos_en = en && ~u_en;
		
		
		always@(posedge clk or negedge rst)begin
		if(rst == 1'b0)
			en <= 1'd0;
		else if(trig)
			en <= 1'd1;
		else if(data_cnt ==8'd11)
			en <= 1'd0;
		end	
	
		always@(posedge clk or negedge rst)begin
		if(rst == 1'b0)
			cnt1 <= 32'd0;
		else if(cnt1 == 32'd150_000)//1000_000 20ms
			cnt1 <= 32'd0;
		else if(control)
			cnt1 <= cnt1 + 1'd1;
	end
	
	always@(posedge clk or negedge rst)begin
		if(!rst)begin
		data_cnt <= 8'b0;
		control <= 1'b0;
		con <= 1'b0;
		end
		else if(en) begin
			if(done )begin
				control <= 1'b1;
			end
			else if(control == 1'b1 && cnt1 == 32'd150_000)begin
				control <= 1'b0;
				data_cnt <= 1'b1 + data_cnt;
				con <= 1'd1;
				end else 
					con <= 1'd0;
			end
		else begin
			data_cnt <= 8'b0;
			control <= 1'b0;
		end
	end
	
	
		always@(posedge clk or negedge rst)
		if(rst == 1'b0)
			u_trig <= 1'd0;
		else
			u_trig <= trig;
			
		always@(posedge clk or negedge rst)
		if(rst == 1'b0)
			u_en <= 1'd0;
		else
			u_en <= en;
			
		always@(posedge clk or negedge rst)
		if(rst == 1'b0)
			en1 <= 1'd0;
		else if(trig)
			en1 <= 1'd1;
			else if(done)
				en1 <= 1'd0;
		
		
		
		always@(posedge clk or negedge rst)
		if(rst == 1'b0)
			stay <= 4'd0;
		else if(trig0)
			stay <= 4'b1000;
			else if(trig1)
				stay <= 4'b0100;
				else if(trig2)
					stay <= 4'b0010;
					else if(trig2)
						stay <= 4'b0001;
		
		
		always@(posedge clk or negedge rst)begin
		if(rst == 1'b0)
			u_start <= 1'd0;
		else if((u_trig !== trig) || pos_en || (en && con))
			u_start <= 1'd1;
		else 
			u_start <= 1'd0;
		end		
	
	
	always@(posedge clk or negedge rst)begin
		if(!rst)begin
		u_data_byte <= 8'd0;
		end
		else begin
		case (stay)
		4'b0001: begin 
				case (data_cnt)	
				8'd0: u_data_byte <= 8'h63;
				8'd1: u_data_byte <= 8'h6C;
				8'd2: u_data_byte <= 8'h69;
				8'd3: u_data_byte <= 8'h63;
				8'd4: u_data_byte <= 8'h6B;
				8'd5: u_data_byte <= 8'h20;
				8'd6: u_data_byte <= 8'h61;
				8'd7: u_data_byte <= 8'h2C;
				8'd8: u_data_byte <= 8'h30;
				8'd9: u_data_byte <= 8'hff;
				8'd10: u_data_byte <= 8'hff;
				8'd11: u_data_byte <= 8'hff;
				endcase
				end
		4'b0010: begin 
				case (data_cnt)	
					8'd0: u_data_byte <= 8'h63;
				8'd1: u_data_byte <= 8'h6C;
				8'd2: u_data_byte <= 8'h69;
				8'd3: u_data_byte <= 8'h63;
				8'd4: u_data_byte <= 8'h6B;
				8'd5: u_data_byte <= 8'h20;
				8'd6: u_data_byte <= 8'h62;
				8'd7: u_data_byte <= 8'h2C;
				8'd8: u_data_byte <= 8'h30;
				8'd9: u_data_byte <= 8'hff;
				8'd10: u_data_byte <= 8'hff;
				8'd11: u_data_byte <= 8'hff;
				endcase
				end
		4'b0100: begin 
				case (data_cnt)	
				8'd0: u_data_byte <= 8'h63;
				8'd1: u_data_byte <= 8'h6C;
				8'd2: u_data_byte <= 8'h69;
				8'd3: u_data_byte <= 8'h63;
				8'd4: u_data_byte <= 8'h6B;
				8'd5: u_data_byte <= 8'h20;
				8'd6: u_data_byte <= 8'h63;
				8'd7: u_data_byte <= 8'h2C;
				8'd8: u_data_byte <= 8'h30;
				8'd9: u_data_byte <= 8'hff;
				8'd10: u_data_byte <= 8'hff;
				8'd11: u_data_byte <= 8'hff;
				endcase
				end
		4'b1000: begin 
				case (data_cnt)	
				8'd0: u_data_byte <= 8'h63;
				8'd1: u_data_byte <= 8'h6C;
				8'd2: u_data_byte <= 8'h69;
				8'd3: u_data_byte <= 8'h63;
				8'd4: u_data_byte <= 8'h6B;
				8'd5: u_data_byte <= 8'h20;
				8'd6: u_data_byte <= 8'h64;
				8'd7: u_data_byte <= 8'h2C;
				8'd8: u_data_byte <= 8'h30;
				8'd9: u_data_byte <= 8'hff;
				8'd10: u_data_byte <= 8'hff;
				8'd11: u_data_byte <= 8'hff;
				endcase
				end
		default: u_data_byte <= 8'h00;
		
		endcase
		end
	end
	//---Module instantiation---
	uart_tx_ckp uart_tx_ckp1(
		.clk(clk),
		.rst(rst),
		.tx_rs232(tx_rs232));

endmodule    //ckp

