module control_ckp(
	data1_t,
	clk,
	rst,
	start0,
	start1,
	start2,
	start3);

	//---Ports declearation: generated by Robei---
	input [7:0] data1_t;
	input clk;
	input rst;
	output start0;
	output start1;
	output start2;
	output start3;

	wire [7:0] data1_t;
	wire clk;
	wire rst;
	reg start0;
	reg start1;
	reg start2;
	reg start3;

	//----Code starts here: integrated by Robei-----
	reg con0;
		reg con1;
		reg con2;
		reg con3;
		reg [31:0] wait_cnt;
		
	parameter WAIT = 25_000_000; //2s 500_000_000
		
	
		always@(posedge clk or negedge rst)begin
		if(rst == 1'b0) begin
			con0 <= 1'd0;
			con1 <= 1'd0;
			con2 <= 1'd0;
			con3 <= 1'd0;
		end
		else if(data1_t >= 8'd30) begin
				con0 <= 1'd1;
				con1 <= 1'd0;
				con2 <= 1'd0;
				con3 <= 1'd0;
				end
			else if(data1_t >= 8'd20) begin
					con1 <= 1'd1;
					con0 <= 1'd0;
					con2 <= 1'd0;
					con3 <= 1'd0;
					end
				else if(data1_t >= 8'd10) begin
						con2 <= 1'd1;
						con0 <= 1'd0;
						con1 <= 1'd0;
						con3 <= 1'd0;
						end
					else if(data1_t >= 8'd0) begin
							con3 <= 1'd1;
							con1 <= 1'd0;
							con2 <= 1'd0;
							con0 <= 1'd0;
							end    
						else begin
								con0 <= 1'd0;
								con1 <= 1'd0;
								con2 <= 1'd0;
								con3 <= 1'd0;
								end
	end
	
		always@(posedge clk or negedge rst)begin
		if(!rst) begin
			start0 <= 1'd0;
			start1 <= 1'd0;
			start2 <= 1'd0;
			start3 <= 1'd0;
		end
		else if(con0 == 1'd1  && wait_cnt == 31'd5_000_000 ) //d50_000_000
			start0 <= 1'd1;
			else if(con1 == 1'd1  && wait_cnt == 31'd5_000_000 )
				start1 <= 1'd1;
				else if(con2 == 1'd1  && wait_cnt == 31'd5_000_000 )
					start2 <= 1'd1;
					else if(con3 == 1'd1  && wait_cnt == 31'd5_000_000 )
						start3 <= 1'd1;
						else begin
							start0 <= 1'd0;
							start1 <= 1'd0;
							start2 <= 1'd0;
							start3 <= 1'd0;
						end
	end
		
		always@(posedge clk or negedge rst)begin
		if(!rst)
			wait_cnt <= 31'd0;
		else if(wait_cnt == WAIT)
			wait_cnt <= 31'd0;
		else if(con0 || con1 || con2 || con3)
			wait_cnt <= wait_cnt + 1'b1;
	end
	
	
	
endmodule    //control_ckp

