module i2c_drive(
	sys_clk,
	sys_rst_n,
	i2c_rw,
	i2c_start,
	i2c_num,
	i2c_addr,
	i2c_data_w,
	i2c_clk,
	i2c_end,
	i2c_data_r,
	scl,
	sda);

	//---Ports declearation: generated by Robei---
	input sys_clk;
	input sys_rst_n;
	input i2c_rw;
	input i2c_start;
	input i2c_num;
	input [15:0] i2c_addr;
	input [7:0] i2c_data_w;
	output i2c_clk;
	output i2c_end;
	output [7:0] i2c_data_r;
	output scl;
	inout sda;

	wire sys_clk;
	wire sys_rst_n;
	wire i2c_rw;
	wire i2c_start;
	wire i2c_num;
	wire [15:0] i2c_addr;
	wire [7:0] i2c_data_w;
	reg i2c_clk;
	reg i2c_end;
	reg [7:0] i2c_data_r;
	reg scl;
	wire sda;

	//----Code starts here: integrated by Robei-----
	 parameter   	DEVICE_ADDR     =   7'b1101000     ,   //i2cӻַ
	   						SYS_CLK_FREQ    =   26'd50_000_000  ,   //ϵͳʱƵ
	   						I2C_FREQ        =   18'd250_000 ;        //i2cʱƵʣ250k
	//״̬		
	localparam	IDLE 			= 4'd0,					//ʼ״̬
				START1			= 4'd1,					//Ϳʼź״̬1
				SEND_D_ADDR_W 	= 4'd2,					//豸ַд״̬ + д
				ACK1			= 4'd3,					//ȴӻӦź1
				SEND_R_ADDR_H	= 4'd4,					//ͼĴַ8λ
				ACK2			= 4'd5,					//ȴӻӦź2
				SEND_R_ADDR_L	= 4'd6,					//ͼĴַ8λ
				ACK3			= 4'd7,					//ȴӻӦź3
				WR_DATA         = 4'd08,  				//д״̬
	            ACK4            = 4'd09,  				//Ӧ״̬4
	            START2          = 4'd10,  				//Ϳʼź״̬12
	            SEND_D_ADDR_R   = 4'd11,  				//豸ַд״̬ + ƶ
	            ACK5            = 4'd12,  				//Ӧ״̬5
	            RD_DATA         = 4'd13,  				//״̬
	            NACK            = 4'd14,  				//Ӧ״̬
	            STOP            = 4'd15;  				//״̬
	 
	//ϵͳƵʼIICƵʼƵϵ			
	localparam	CLK_DIVIDE = SYS_CLK_FREQ / I2C_FREQ >> 2'd3;	
	 
	//reg			
	reg	[9:0]	clk_cnt			;						//ƵʱӼ1023			
	reg	[3:0]	cur_state		;						//״̬̬	 
	reg	[3:0]	next_state		;						//״̬̬	
	reg			i2c_clk_cnt_en	;			 			//ʱӼʹ
	reg	[1:0]	i2c_clk_cnt		;			 			//ʱӣSCLĸߵƽмɼݣSCLĵ͵ƽм仯
	reg			sda_out			;						//IIC̬
	reg			sda_en			;						//IIC̬ʹ
	reg [2:0]	bit_cnt			;						//ݸ
	reg			ack_flag		;						//Ӧźű־
	reg	[7:0]	i2c_data_r_temp	;						//ȡݼĴݴ
				
	//wire		
	wire		sda_in			;						//IIC̬
	wire [7:0]	addr_r			;						//ַ+λ
	wire [7:0]	addr_w			;						//ַ+дλ
			
	assign addr_r = {DEVICE_ADDR,1'b1};					//ַ+λ
	assign addr_w = {DEVICE_ADDR,1'b0};					//ַ+дλ
	 
	//˫ڴ
	assign sda_in = sda;				
	assign sda = sda_en ? sda_out : 1'bz;
	 
	//scl4Ƶʱ=IICʱi2c_clkԲɼݼ仯ݲ
	always@(posedge sys_clk or negedge sys_rst_n)begin
		if(~sys_rst_n)begin
			i2c_clk <= 1'b0;
			clk_cnt <= 10'd0;
		end
		else if(clk_cnt == CLK_DIVIDE - 1'b1)begin
			i2c_clk <= ~i2c_clk;
			clk_cnt <= 10'd0;		
		end
		else begin
			i2c_clk <= i2c_clk;
			clk_cnt <= clk_cnt + 1'd1;	
		end
	end
	 
	//i2c_clkʹ
	always@(posedge i2c_clk or negedge sys_rst_n)begin
		if(!sys_rst_n)
			i2c_clk_cnt_en <= 1'b0;
		//ֻڷ˽źŻûнյIICʼźŵĳʼ״̬²Ųͣi2c_clkλʹΪ0
	 	else if ((cur_state == STOP && i2c_clk_cnt == 2'd3 && bit_cnt == 2'd3)||(cur_state == IDLE && !i2c_start ))
			i2c_clk_cnt_en <= 1'b0; 
		else if(i2c_start)							
			i2c_clk_cnt_en <= 1'b1;							//յʼźţһδ俪ʼʼ
		else											
			i2c_clk_cnt_en <= i2c_clk_cnt_en;				//ʱ򱣳ֲ
	end
	 
	//i2c_clk_cnt
	always@(posedge i2c_clk or negedge sys_rst_n)begin
		if(!sys_rst_n)
			i2c_clk_cnt <= 2'd0;
		else if(i2c_clk_cnt_en)						
			i2c_clk_cnt <= i2c_clk_cnt + 1'd1;				//ʹźЧʼ
		else		
			i2c_clk_cnt <= 2'd0;							//ʹźЧ
	end
		
	//ʽ״̬һ
	always@(posedge i2c_clk or negedge sys_rst_n)begin
		if(~sys_rst_n)
			cur_state <= IDLE;
		else
			cur_state <= next_state;
	end
	 
	//ʽ״̬ڶ
	always@(*)begin
		next_state = IDLE;
		case(cur_state)
			IDLE:
				if(i2c_start)
					next_state = START1;					//յʼźţתʼź״̬
				else
					next_state = IDLE;
			START1:
				if(i2c_clk_cnt == 2'd3)						//i2c_clk ֵ3תַ+д־λ״̬
					next_state = SEND_D_ADDR_W;
				else
					next_state = START1;
			SEND_D_ADDR_W:
				if(i2c_clk_cnt == 2'd3 && bit_cnt == 3'd7)	//8λַתӻӦ״̬
					next_state = ACK1;	
				else
					next_state = SEND_D_ADDR_W;			
			ACK1:
				if(ack_flag && i2c_clk_cnt == 2'd3)begin	//Ӧ־Ч
					//ݵַ״̬λж16λַ8λַӶתͬ״̬
					if(i2c_num)								//16λַ
						next_state = SEND_R_ADDR_H;			//תĴ8λַ״̬
					else									//8λַ
						next_state = SEND_R_ADDR_L;			//תĴ8λַ״̬
				end	
				else if(i2c_clk_cnt == 2'd3)				//ӦЧӦʱתسʼ״̬
					next_state = IDLE;
				else 
					next_state = ACK1;
	 		SEND_R_ADDR_H:									
				if(i2c_clk_cnt == 2'd3 && bit_cnt == 3'd7)	//˼Ĵ8λַתӻӦ״̬
					next_state = ACK2;
				else										
					next_state = SEND_R_ADDR_H;
			ACK2:
				if(ack_flag && i2c_clk_cnt == 2'd3)			
					next_state = SEND_R_ADDR_L;				//Ӧ־ЧתĴ8λַ״̬
				else if(i2c_clk_cnt == 2'd3)				//ӦЧӦʱתسʼ״̬
					next_state = IDLE;	
				else
					next_state = ACK2;
			SEND_R_ADDR_L:
				if(i2c_clk_cnt == 2'd3 && bit_cnt == 3'd7)	//˼Ĵ8λַתӻӦ״̬
					next_state = ACK3;
				else
					next_state = SEND_R_ADDR_L;
			ACK3:
				if(ack_flag && i2c_clk_cnt == 2'd3)begin	//Ӧ־Ч	
					if(i2c_rw)								//״̬
						next_state = START2;				//תڶηʼź
					else									//д״̬
						next_state = WR_DATA;				//תд״̬
				end
				else if(i2c_clk_cnt == 2'd3)				
					next_state = IDLE;						//ӦЧӦʱתسʼ״̬
				else
					next_state = ACK3;
			START2:
				if(i2c_clk_cnt == 2'd3)						
					next_state = SEND_D_ADDR_R;				//ڶηʼźźתַ+־λ״̬
				else
					next_state = START2;
			SEND_D_ADDR_R:
				if(i2c_clk_cnt == 2'd3 && bit_cnt == 3'd7)	//8λַתӻӦ״̬
					next_state = ACK5;	
				else
					next_state = SEND_D_ADDR_R;			
			ACK5:
				if(ack_flag && i2c_clk_cnt == 2'd3)			
					next_state = RD_DATA;                   //Ӧ־Чת״̬
				else if(i2c_clk_cnt == 2'd3)                
					next_state = IDLE;				        //ӦЧӦʱתسʼ״̬
				else                                        
					next_state = ACK5;		
			RD_DATA:
				if(i2c_clk_cnt == 2'd3 && bit_cnt == 3'd7)	//8λݺתͷӦ״̬
					next_state = NACK;
				else
					next_state = RD_DATA;		
			NACK:
				if(i2c_clk_cnt == 2'd3)						
					next_state = STOP;						//˷Ӧźźתͽź״̬
				else
					next_state = NACK;						
			WR_DATA:
				if(bit_cnt == 3'd7 && i2c_clk_cnt == 2'd3)	
					next_state = ACK4;						//д8λݺתӻӦ״̬
				else
					next_state = WR_DATA;
			ACK4:
				if(ack_flag && i2c_clk_cnt == 2'd3)
					next_state = STOP;						//Ӧ־Чתͽź״̬
				else if(i2c_clk_cnt == 2'd3)
					next_state = IDLE;						//ӦЧӦʱתسʼ״̬
				else
					next_state = ACK4;
			STOP:
				if(bit_cnt == 2'd3 && i2c_clk_cnt == 2'd3)	//źŷϣﻹԤ2ڣתʼ״̬ȴһδ俪ʼź
					next_state = IDLE;
				else
					next_state = STOP;		
			default:next_state = IDLE;
		endcase
	end
	 
	//ʽ״̬
	always@(posedge i2c_clk or negedge sys_rst_n)begin
		if(~sys_rst_n)begin								//ʼ״̬
			sda_en <= 1'b1;
			sda_out <= 1'b1;
			bit_cnt	<= 3'd0;
			i2c_end <= 1'b0;
			i2c_data_r <= 8'd0;
			i2c_data_r_temp <= 8'd0;
		end
		else begin
			i2c_end <= 1'b0;
			case(cur_state)
				IDLE:begin
					sda_en <= 1'b1;						//
					sda_out <= 1'b1;					//
				end	
				START1:begin
						if(i2c_clk_cnt == 2'd3)begin	//˿ʼź
							if(addr_w[7])begin			//ַλΪ1ǰ
								sda_en <= 1'b1;
								sda_out <= 1'b1;													
							end
							else begin					//ַλΪ0ǰ
								sda_en <= 1'b1;
								sda_out <= 1'b0;												
							end
						end
						else begin						//û꿪ʼź򱣳ֵ͵ƽ
							sda_en <= 1'b1;
							sda_out <= 1'b0;					
						end
				end	
				SEND_D_ADDR_W:begin
					if(bit_cnt == 3'd7)begin			
						if(i2c_clk_cnt == 2'd3)begin	//8ݣַ+д־λ
							bit_cnt <= 3'd0;			//ݼ
							sda_en <= 1'b0;				//ͷ
						end
					end
					else if(i2c_clk_cnt == 2'd3)begin	//һ
						bit_cnt <= bit_cnt + 1'd1;		//ݼ
						sda_en <= 1'b1;					//
						sda_out <= addr_w[6-bit_cnt];	//δַ
					end
				end
				ACK1:begin
	  				if(i2c_clk_cnt == 2'd3)begin				
						if(i2c_num)begin				//ַΪ16λ
							if(i2c_addr[15])begin		//ַ16λΪ1ǰ
								sda_en <= 1'b1;
								sda_out <= 1'b1;	
							end
							else begin					//ַ16λΪ0ǰ
								sda_en <= 1'b1;
								sda_out <= 1'b0;	
							end
						end
						else begin						//ַΪ8λ
							if(i2c_addr[7])begin		//ַ8λΪ1ǰ
								sda_en <= 1'b1;
								sda_out <= 1'b1;	
							end
							else begin					//ַ8λΪ0ǰ
								sda_en <= 1'b1;
								sda_out <= 1'b0;	
							end
						end			
					end 
				end
				SEND_R_ADDR_H:begin
					if(bit_cnt == 3'd7)begin			//8ݷ
						if(i2c_clk_cnt == 2'd3)begin
							bit_cnt <= 3'd0;			//ݼ
							sda_en <= 1'b0;				//ͷ
						end
					end
					else if(i2c_clk_cnt == 2'd3)begin
						bit_cnt <= bit_cnt + 1'd1;		//ݼ
						sda_en <= 1'b1;                 //
						sda_out <= i2c_addr[14-bit_cnt];//δַ
					end			
				end
				ACK2:begin
					if(i2c_clk_cnt == 2'd3)begin
						if(i2c_addr[7])begin			//һҪݵ׸Ϊǰ
							sda_en <= 1'b1;
							sda_out <= 1'b1;													
						end
						else begin						//һҪݵ׸Ϊǰ
							sda_en <= 1'b1;
							sda_out <= 1'b0;												
						end				
					end
				end	
				SEND_R_ADDR_L:begin	
					if(bit_cnt == 3'd7)begin				//8ݷ
						if(i2c_clk_cnt == 2'd3)begin
							bit_cnt <= 3'd0;				//ݼ
							sda_en <= 1'b0;					//ͷ
						end
					end
					else if(i2c_clk_cnt == 2'd3)begin
							bit_cnt <= bit_cnt + 1'd1;		//ݼ
							sda_en <= 1'b1;                 //
							sda_out <= i2c_addr[6-bit_cnt]; //δַ
					end			
				end
				ACK3:begin
					if(!i2c_rw)begin					//д
						if(i2c_clk_cnt == 2'd3)begin
							if(i2c_data_w[7])begin		//һҪݵ׸Ϊǰ
								sda_en <= 1'b1;
								sda_out <= 1'b1;													
							end
							else begin					//һҪݵ׸Ϊǰ
								sda_en <= 1'b1;
								sda_out <= 1'b0;												
							end				
						end 
					end
					else begin							//Ƕ
						if(i2c_clk_cnt == 2'd3)begin	//ǰ߽ٴηʼź״̬
							sda_en <= 1'b1;
							sda_out <= 1'b1;								
						end
						else begin
							sda_en <= 1'b1;
							sda_out <= 1'b0;												
						end				
					end
				end
				START2:begin
					if(i2c_clk_cnt == 2'd1)begin		//
						sda_en <= 1'b1;
						sda_out <= 1'b0;						
					end
					else if(i2c_clk_cnt == 2'd3)begin
						if(addr_r[7])begin				//һҪݵ׸Ϊǰ
							sda_en <= 1'b1;
							sda_out <= 1'b1;													
						end
						else begin						//һҪݵ׸Ϊǰ
							sda_en <= 1'b1;
							sda_out <= 1'b0;												
						end						
					end
				end
				SEND_D_ADDR_R:begin
					if(bit_cnt == 3'd7)begin				//8ݷ
						if(i2c_clk_cnt == 2'd3)begin
							bit_cnt <= 3'd0;				//ݼ
							sda_en <= 1'b0;					//ͷ
						end
					end
					else if(i2c_clk_cnt == 2'd3)begin
							bit_cnt <= bit_cnt + 1'd1;		//ݼ
							sda_en <= 1'b1;                 //
							sda_out <= addr_r[6-bit_cnt];   //δַ
					end
				end		
				ACK5:
					sda_en <= 1'b0;							//һ״̬ǽݣͷ
				RD_DATA:
					if(i2c_clk_cnt == 2'd3)begin
						if(bit_cnt == 3'd7)begin			//8
							bit_cnt <= 3'd0;				//ݼ
							sda_en <= 1'b1;					//
							sda_out <= 1'b1;                //ߣΪһͷӦźţ
							i2c_data_r <= i2c_data_r_temp;	//ȡ						
						end
						else begin							//ݻδ		
							bit_cnt <= bit_cnt + 3'd1;				
						end				
					end
					else if(i2c_clk_cnt == 2'd1)begin		//SCLмɼ
						i2c_data_r_temp[7-bit_cnt] <=sda_in;//ϵδвɼ				
					end							
				NACK:
	 				if(i2c_clk_cnt == 2'd3)begin			
						sda_en <= 1'b1;						//
						sda_out <= 1'b0;					//																					
					end				
				WR_DATA:
					if(bit_cnt == 3'd7)begin				//д8
						if(i2c_clk_cnt == 2'd3)begin
							bit_cnt <= 3'd0;				//ݼ
							sda_en <= 1'b0;					//ͷ
						end
					end
					else if(i2c_clk_cnt == 2'd3)begin		//ûд8
						bit_cnt <= bit_cnt + 1'd1;			//ݼۼ
						sda_en <= 1'b1;
						sda_out <= i2c_data_w[6-bit_cnt];	//
					end	
				ACK4:
	 				if(i2c_clk_cnt == 2'd3)begin
						sda_en <= 1'b1;						//
						sda_out <= 1'b0;					//ߣΪһֹźţ																					
					end				 
				STOP:				
	 				if(i2c_clk_cnt == 2'd2 && bit_cnt == 2'd0)begin	//źΪֹź	
						sda_en <= 1'b1;
						sda_out <= 1'b1;																									
					end
					else if( i2c_clk_cnt == 2'd3 )begin
						if(bit_cnt == 2'd3)begin					
							bit_cnt <= 2'd0;
							i2c_end <= 1'b1;				//ֹźʱһʱ䷢IICź
						end
						else
							bit_cnt <= bit_cnt + 1'd1;
					end
				default:;
			endcase
		end
	end
	 
	//i2cʱ
	always@(posedge i2c_clk or negedge sys_rst_n)begin
		if(~sys_rst_n)
			scl <= 1'b1;
		else if(cur_state != STOP)begin
			if(i2c_clk_cnt == 2'd2)
				scl <= 1'b0;
			else if(i2c_clk_cnt == 2'd0)
				scl <= 1'b1;	
		end
		else 
			scl <= 1'b1;
	end
	//ӻӦźű־
	always@(posedge i2c_clk or negedge sys_rst_n)begin
		if(~sys_rst_n)
			ack_flag <= 1'b0;
		else 
			case(cur_state)
				ACK1,ACK2,ACK3,ACK4,ACK5:
					if(i2c_clk_cnt == 2'd1 && !sda_in)		//ڴӻӦ״̬ȷյ˴ӻ͵ӦźӦ־
						ack_flag <= 1'b1;
					else if(i2c_clk_cnt == 2'd3)			
						ack_flag <= 1'b0;
				default:ack_flag <= 1'b0;
			endcase
	end
	
	
endmodule    //i2c_drive

