module jq8900(
	clk,
	rst,
	trig,
	tx_rs232);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst;
	input trig;
	output tx_rs232;

	wire clk;
	wire rst;
	wire trig;
	wire tx_rs232;

	//----Code starts here: integrated by Robei-----
	
	wire [7:0] data_byte;
		wire done;
		wire start;
		
		reg [7:0] u_data_byte;
		reg [3:0] data_cnt;
		reg en;
		reg u_start;
		reg control;
		reg [31:0] cnt;
		reg [31:0] cnt1;
		reg tx_end;
		reg con;
		
		
	uart_tx u_uart_tx(
		.clk(clk),
		.rst(rst),
		.data_byte(data_byte),
		.start(start),
		.tx_rs232(tx_rs232),
		.done(done)
	    );
		
	assign 	data_byte = u_data_byte;
	assign 	start = u_start;
	
		always@(posedge clk or negedge rst)begin
		if(rst == 1'b0)
			tx_end <= 1'd0;
		else if(done)
			tx_end <= 1'd1;
		else
			tx_end <= 1'd0;
		end	
		
		always@(posedge clk or negedge rst)begin
		if(rst == 1'b0)
			en <= 1'd0;
		else if(trig)
			en <= 1'd1;
		else if(data_cnt ==8'd6)
			en <= 1'd0;
		end	
		
		always@(posedge clk or negedge rst)begin
		if(rst == 1'b0)
			u_start <= 1'd0;
		else if((en && con)|| trig)
			u_start <= 1'd1;
		else 
			u_start <= 1'd0;
		end		
	
		always@(posedge clk or negedge rst)begin
		if(rst == 1'b0)
			cnt1 <= 32'd0;
		else if(cnt1 == 32'd150_000)//1000_000 20ms
			cnt1 <= 32'd0;
		else if(control)
			cnt1 <= cnt1 + 1'd1;
	end
	
	always@(posedge clk or negedge rst)begin
		if(!rst)begin
		data_cnt <= 8'b0;
		control <= 1'b0;
		con <= 1'b0;
		end
		else if(en) begin
			if(done )begin
				control <= 1'b1;
			end
			else if(control == 1'b1 && cnt1 == 32'd150_000)begin
				control <= 1'b0;
				data_cnt <= 1'b1 + data_cnt;
				con <= 1'd1;
				end else 
					con <= 1'd0;
			end
		else begin
			data_cnt <= 8'b0;
			control <= 1'b0;
		end
	end
	always@(posedge clk or negedge rst)begin
		if(!rst)begin
		u_data_byte <= 8'd0;
		end
		else begin
		case (data_cnt)
		8'd0: u_data_byte <= 8'h7E;
		8'd1: u_data_byte <= 8'h05;
		8'd2: u_data_byte <= 8'h41;
		8'd3: u_data_byte <= 8'h00;
		8'd4: u_data_byte <= 8'h02;
		8'd5: u_data_byte <= 8'h46;
		8'd6: u_data_byte <= 8'hEF;
		endcase
		end
	end
	//---Module instantiation---
	uart_tx uart_tx1(
		.clk(clk),
		.rst(rst),
		.tx_rs232(tx_rs232));

endmodule    //jq8900

