module pwm(
	start,
	start1,
	start2,
	clk,
	rst_n,
	s_da_in1,
	s_da_in2,
	finish,
	pwm_out);

	//---Ports declearation: generated by Robei---
	input start;
	input start1;
	input start2;
	input clk;
	input rst_n;
	input [3:0] s_da_in1;
	input [3:0] s_da_in2;
	input finish;
	output pwm_out;

	wire start;
	wire start1;
	wire start2;
	wire clk;
	wire rst_n;
	wire [3:0] s_da_in1;
	wire [3:0] s_da_in2;
	wire finish;
	reg pwm_out;

	//----Code starts here: integrated by Robei-----
	parameter      		S=1000_000,//20ms		T
						S0=110_000,//2.5ms		-90
						S1=85_000,//2ms			-45
						S2=60_000,//1.5ms		0		
						S3=35_000,//1ms			45
						S4=20_000;//0.5ms		90
			
	reg control;					
	reg	[31:0]  cnt_r;	
	reg	[31:0]	cnt;
	/* reg	[63:0]	wait_cnt1;	
	reg	[63:0]	wait_cnt2;	 */		
	reg [3:0]   da_in;
	
	//reg stop1;
	//reg stop2;				
	reg en;
	
	always@(posedge clk or negedge rst_n)begin
		if(!rst_n)
			en <= 1'd0;
			else if(start)
				en <= 1'd1;
				else if(finish)
					en <= 1'd0;
	end
	
	always@(posedge clk or negedge rst_n)begin
		if(!rst_n)
			da_in <= 4'd0;
		else begin
			if(control)
			da_in <= s_da_in2;
			else da_in <= s_da_in1;
			
		end
	end
	
	always@(*)begin
		if(!rst_n)
			cnt_r <= 31'd0;
		else
			begin
				case(da_in)
					4'd0: cnt_r <= S0;
					4'd1: cnt_r <= S1;
					4'd2: cnt_r <= S2;
					4'd3: cnt_r <= S3;
					4'd4: cnt_r <= S4;
					default: cnt_r <= 1'd0;
				endcase
			end
	end
	
	always@(posedge clk or negedge rst_n)begin
		if(!rst_n)
			cnt <= 31'd0;
		else if(cnt == S) 
			cnt <= 31'd0;
		else 
			cnt <= cnt + 1'b1;
	end
	
	always@(posedge clk or negedge rst_n)begin
		if(!rst_n) begin
			control <= 1'd0;
			// stop1 <= 1'd0;
			// stop2 <= 1'd0;
		end
			else if(en)begin 
			if(start1) begin
				control <= 1'd1;
				//stop1 <= 1'd1;
			end
			if(start2)begin
				control <= 1'd0;
				//stop2 <= 1'd1;
			end
		end
	end
	
	/* always@(posedge clk or negedge rst_n)begin
		if(!rst_n)
			wait_cnt1 <= 31'd0;
		else if(wait_cnt1 == WAIT1 || stop1)
			wait_cnt1 <= 31'd0;
		else if(en)
			wait_cnt1 <= wait_cnt1 + 1'b1;
	end
	
	always@(posedge clk or negedge rst_n)begin
		if(!rst_n)
			wait_cnt2 <= 31'd0;
		else if(wait_cnt2 == WAIT2 || stop2)
			wait_cnt2 <= 31'd0;
		else if(en)
			wait_cnt2 <= wait_cnt2 + 1'b1;
	end */
	
	always@(posedge clk or negedge rst_n)begin
		if(!rst_n)
			pwm_out <= 1'b0;
		else if(cnt <= cnt_r )
				pwm_out <= 1'b1;
				else
					pwm_out <= 1'b0;
	end
	
	
	
endmodule    //pwm

