module top_dht(
	sys_clk,
	sys_rst_n,
	seg_led,
	sel,
	data0_t,
	data1_t,
	data0_w,
	data1_w,
	datat1,
	datat2,
	datat3,
	 datat4,
	dataw1,
	dataw2,
	dataw3,
	dataw4,
	dht11);

	//---Ports declearation: generated by Robei---
	input sys_clk;
	input sys_rst_n;
	output [6:0] seg_led;
	output [5:0] sel;
	output [7:0] data0_t;
	output [7:0] data1_t;
	output [7:0] data0_w;
	output [7:0] data1_w;
	output [3:0] datat1;
	output [3:0] datat2;
	output [3:0] datat3;
	output [3:0]  datat4;
	output [3:0] dataw1;
	output [3:0] dataw2;
	output [3:0] dataw3;
	output [3:0] dataw4;
	inout dht11;

	wire sys_clk;
	wire sys_rst_n;
	reg [6:0] seg_led;
	reg [5:0] sel;
	reg [7:0] data0_t;
	reg [7:0] data1_t;
	reg [7:0] data0_w;
	reg [7:0] data1_w;
	reg [3:0] datat1;
	reg [3:0] datat2;
	reg [3:0] datat3;
	reg [3:0]  datat4;
	reg [3:0] dataw1;
	reg [3:0] dataw2;
	reg [3:0] dataw3;
	reg [3:0] dataw4;
	wire dht11;

	//----Code starts here: integrated by Robei-----
	wire [31:0] data;
		reg [6:0] dir;
		reg [3:0] a;
		reg clk1;
		reg [3:0] cnt;
		reg [15:0] cnt1;
	always@(posedge sys_clk or negedge sys_rst_n ) 
	begin
	if(!sys_rst_n) begin
	datat1 <= 4'd0;
	datat2 <= 4'd0;
	datat3 <= 4'd0;
	datat4 <= 4'd0;
	dataw1 <= 4'd0;
	dataw2 <= 4'd0;
	dataw3 <= 4'd0;
	dataw4 <= 4'd0;
	end else begin
		datat1 <= data0_t%10;
		datat2 <= data0_t/10;
		datat3 <= data1_t%10;
		datat4 <= data1_t/10;
		dataw1 <= data0_w%10;
		dataw2 <= data0_w/10;
		dataw3 <= data1_t%10;
		dataw4 <= data1_t/10;
	end
	end
		
	always@(posedge sys_clk or negedge sys_rst_n ) 
	begin
	if(!sys_rst_n) begin
	data0_t <= 8'd0;
	data1_t <= 8'd0;
	data0_w <= 8'd0;
	data1_w <= 8'd0;
	end else begin
		data0_t <= data[7:0];  //¶СλΪλ
	    data1_t <= data[15:8];
	    data0_w <= data[23:16];
	    data1_w <= data[31:24];
	end
	end
	always @(posedge clk1 or negedge sys_rst_n)
	begin
	if(!sys_rst_n)
	cnt<=4'd0;
	else if(cnt<4'd5)
	cnt<=cnt+1;
	else
	cnt<=4'd0;
	end
	always@(posedge sys_clk or negedge sys_rst_n ) 
	begin
	    if(!sys_rst_n)
	        cnt1 <= 16'd0;
	    else if (cnt1 <= 16'd50000)
	        cnt1 <= cnt1 +1'b1;
	    else
	        cnt1 <= 16'd0;
	end
	always @(posedge sys_clk or negedge sys_rst_n)
	begin
	if(!sys_rst_n)
	clk1<=0;
	else if(cnt1==16'd24999)
	clk1<=0;
	else
	clk1<=1;
	end
	always @(posedge sys_clk or negedge sys_rst_n)
	begin
	if(!sys_rst_n)
	dir<=7'b1111_111;
	else 
		case(a)
		4'b0000: dir<=7'b1000_000; //0	abcdef
		4'b0001: dir<=7'b1111_001; //1	bc
		4'b0010: dir<=7'b0100_100; //2	abdeg
		4'b0011: dir<=7'b0110_000; //3	abcdg
		4'b0100: dir<=7'b0011_001; //4	bcfg
		4'b0101: dir<=7'b0010_010; //5	acdfg
		4'b0110: dir<=7'b0000_010; //6	acdefg
		4'b0111: dir<=7'b1111_000; //7	abc
		4'b1000: dir<=7'b0000_000; //8	abcdefg
		4'b1001: dir<=7'b0010_000; //9	abcdfg
		endcase
		end
	always@(posedge sys_clk or negedge sys_rst_n)
	begin
	if(!sys_rst_n)
	sel<=6'd11_1111;
	else case(cnt)
	6'd0:sel<=6'b11_1110;
	6'd1:sel<=6'b11_1101;
	6'd2:sel<=6'b11_1011;
	6'd3:sel<=6'b11_0111;
	6'd4:sel<=6'b10_1111;
	6'd5:sel<=6'b01_1111; 
	endcase
	end
	always@(posedge sys_clk or negedge sys_rst_n)
	begin
	if(!sys_rst_n)
	seg_led<=7'b1111_111;
	else case(sel)
	6'b11_1110: begin	a <= datat1;
					seg_led <= dir;
			end
	6'b11_1101: begin	a <= datat2;
					seg_led <= dir;
			end
	6'b11_1011:begin	a <= datat3;
					seg_led <= dir;
			end
	6'b11_0111:begin	a <= datat4;
					seg_led <= dir;
			end                                                                 
	6'b10_1111:begin	a <= dataw3;
					seg_led <= dir;
			end
	6'b01_1111:begin	a <= dataw4;
					seg_led <= dir;
			end
	endcase
	end
	
	
	
	//---Module instantiation---
	dht11_ dht11_1(
		.sys_clk(sys_clk),
		.rst_n(sys_rst_n),
		.dht11(dht11));

endmodule    //top_dht

