module top_dhtjq(
	clk,
	rst,
	tx_rs232,
	seg_led,
	sel,
	dht11);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst;
	output tx_rs232;
	output [6:0] seg_led;
	output [5:0] sel;
	inout dht11;

	wire clk;
	wire rst;
	wire tx_rs232;
	wire [6:0] seg_led;
	wire [5:0] sel;
	wire dht11;
	wire control3_start;
	wire [3:0] datat4;

	//----Code starts here: integrated by Robei-----
	wire [3:0] data0_t;
		wire [3:0] data1_t;
		wire [3:0] data0_w;
		wire [3:0] data1_w;
		
		wire [3:0] datat1;
		wire [3:0] datat2;
		wire [3:0] datat3;
		     
		wire [3:0] dataw1;
		wire [3:0] dataw2;
		wire [3:0] dataw3;
		wire [3:0] dataw4;
		
		wire trig;
		wire con;
		
	parameter WAIT =500_000_000; //2s 500_000_000
	
	jq8900 u_jq8900(
			.clk(clk),
			.rst(rst),
			.tx_rs232(tx_rs232),
			.trig(trig)
	    );
	top_dht u_dht(
			.sys_clk(clk),
			.sys_rst_n(rst),
			.seg_led(seg_led),
			.sel(sel),
			.dht11(dht11),
			.data0_t(data0_t),
			.data1_t(data1_t),
			.data0_w(data0_w),
			.data1_w(data1_w),
			.datat1(datat1),
			.datat2(datat2),
			.datat3(datat3),
			.dataw1(dataw1),
			.dataw2(dataw2),
			.dataw3(dataw3),
			.dataw4(dataw4)
			
			
		); 
	
		control u_control(
		.clk(clk),
		.rst(rst),
		.con(con),
		.start(trig),
		.datat4(datat4)
		
	    );
	//---Module instantiation---
	control control3(
		.datat4(datat4),
		.clk(clk),
		.rst(rst),
		.start(control3_start));

	top_dht top_dht2(
		.sys_clk(clk),
		.sys_rst_n(rst),
		. datat4(datat4),
		.dht11(dht11));

	jq8900 jq89003(
		.clk(clk),
		.rst(rst),
		.trig(control3_start),
		.tx_rs232(tx_rs232));

endmodule    //top_dhtjq

