module top_ds1307(
	sys_clk,
	sys_rst_n,
	scl,
	sda,
	seg_led,
	sel);

	//---Ports declearation: generated by Robei---
	input sys_clk;
	input sys_rst_n;
	output scl;
	inout sda;
	output [6:0] seg_led;
	output [5:0] sel;

	wire sys_clk;
	wire sys_rst_n;
	wire scl;
	wire sda;
	reg [6:0] seg_led;
	reg [5:0] sel;
	wire i2c_drive2_i2c_end;
	wire [7:0] i2c_drive2_i2c_data_r;
	wire [15:0] ds13072_i2c_addr;
	wire [7:0] ds13072_i2c_data_w;
	wire i2c_drive2_i2c_clk;

	//----Code starts here: integrated by Robei-----
		parameter   DEVICE_ADDR     =   7'b1101000     ;   //i2cӻַ
	    parameter   SYS_CLK_FREQ    =   26'd50_000_000 ;   //ϵͳʱƵ
	    parameter   I2C_FREQ        =   18'd250_000    ;    //i2cʱƵʣ250k
		
		reg [6:0] dir;
		reg [3:0] a;
		reg clk1;
		reg [3:0] cnt;
		reg [15:0] cnt1;
		
		wire [7:0]hour;
		wire [7:0]min;
		wire [7:0]sec;
	
		
		wire			i2c_rw		;	
		wire	        i2c_start   ;   
		wire	        i2c_num    	;   
		wire	[15:0]  i2c_addr   	;   
		wire	[7:0]   i2c_data_w	;   
		wire			i2c_clk     ;   
		wire			i2c_end     ;   
		wire	[7:0]   i2c_data_r  ;
		        				
		
		
		
		
		ds1307 u_ds1307(
		.i2c_clk(i2c_clk),
		.rst_n(sys_rst_n),
		.min(min),
		.sec(sec),
		.hour(hour),
		.i2c_addr(i2c_addr),
		.i2c_rw(i2c_rw),
		.i2c_start(i2c_start),
		.i2c_data_w(i2c_data_w),
		.i2c_end(i2c_end),
		.i2c_data_r(i2c_data_r)
	    );
		i2c_drive  u_i2c_drive(
	
	    .sys_clk(sys_clk)     ,   			//ϵͳʱ,50MHz
	    .sys_rst_n(sys_rst_n)   ,   			//븴λź,͵ƽЧ				
		.i2c_rw(i2c_rw)		,				
	    .i2c_start(i2c_start)   ,   			
	    .i2c_num(1'b0)    	,   			//i2cֽڵַֽ----116λ08λ
	    .i2c_addr(i2c_addr)   	,   			
	    .i2c_data_w(i2c_data_w)	,   			
	    .i2c_clk(i2c_clk)     ,   			
	    .i2c_end(i2c_end)     ,   			
	    .i2c_data_r(i2c_data_r)  ,   						
	    .scl(scl)     	,   			//i2c豸Ĵʱźscl
	    .sda(sda)         				//i2c豸Ĵźsda
	);		
	 
		
	always @(posedge clk1 or negedge sys_rst_n)
	begin
	if(!sys_rst_n)
	cnt<=4'd0;
	else if(cnt<4'd5)
	cnt<=cnt+1;
	else
	cnt<=4'd0;
	end
	always@(posedge sys_clk or negedge sys_rst_n ) 
	begin
	    if(!sys_rst_n)
	        cnt1 <= 16'd0;
	    else if (cnt1 <= 16'd50000)
	        cnt1 <= cnt1 +1'b1;
	    else
	        cnt1 <= 16'd0;
	end
	always @(posedge sys_clk or negedge sys_rst_n)
	begin
	if(!sys_rst_n)
	clk1<=0;
	else if(cnt1==16'd24999)
	clk1<=0;
	else
	clk1<=1;
	end
	always @(posedge sys_clk or negedge sys_rst_n)
	begin
	if(!sys_rst_n)
	dir<=7'b1111_111;
	else 
		case(a)
		4'b0000: dir<=7'b1000_000; //0	abcdef
		4'b0001: dir<=7'b1111_001; //1	bc
		4'b0010: dir<=7'b0100_100; //2	abdeg
		4'b0011: dir<=7'b0110_000; //3	abcdg
		4'b0100: dir<=7'b0011_001; //4	bcfg
		4'b0101: dir<=7'b0010_010; //5	acdfg
		4'b0110: dir<=7'b0000_010; //6	acdefg
		4'b0111: dir<=7'b1111_000; //7	abc
		4'b1000: dir<=7'b0000_000; //8	abcdefg
		4'b1001: dir<=7'b0010_000; //9	abcdfg
		endcase
		end
	always@(posedge sys_clk or negedge sys_rst_n)
	begin
	if(!sys_rst_n)
	sel<=6'd11_1111;
	else case(cnt)
	6'd0:sel<=6'b11_1110;
	6'd1:sel<=6'b11_1101;
	6'd2:sel<=6'b11_1011;
	6'd3:sel<=6'b11_0111;
	6'd4:sel<=6'b10_1111;
	6'd5:sel<=6'b01_1111; 
	endcase
	end
	always@(posedge sys_clk or negedge sys_rst_n)
	begin
	if(!sys_rst_n)
	seg_led<=7'b1111_111;
	else case(sel)
	6'b11_1110: begin	a <= sec[3:0];
					seg_led <= dir;
			end
	6'b11_1101: begin	a <= sec[7:4];
					seg_led <= dir;
			end
	6'b11_1011:begin	a <= min[3:0];
					seg_led <= dir;
			end
	6'b11_0111:begin	a <= min[7:4];
					seg_led <= dir;
			end                                                                 
	6'b10_1111:begin	a <= hour[3:0];
					seg_led <= dir;
			end
	6'b01_1111:begin	a <= hour[7:4];
					seg_led <= dir;
			end
	endcase
	end
	//---Module instantiation---
	i2c_drive i2c_drive2(
		.sys_clk(sys_clk),
		.sys_rst_n(sys_rst_n),
		.i2c_addr(ds13072_i2c_addr),
		.i2c_data_w(ds13072_i2c_data_w),
		.i2c_clk(i2c_drive2_i2c_clk),
		.i2c_end(i2c_drive2_i2c_end),
		.i2c_data_r(i2c_drive2_i2c_data_r),
		.scl(scl),
		.sda(sda));

	ds1307 ds13072(
		.i2c_clk(i2c_drive2_i2c_clk),
		.rst_n(sys_rst_n),
		.i2c_end(i2c_drive2_i2c_end),
		.i2c_data_r(i2c_drive2_i2c_data_r),
		.i2c_addr(ds13072_i2c_addr),
		.i2c_data_w(ds13072_i2c_data_w));

endmodule    //top_ds1307

