module top_pwm_5(
	clk,
	rst_n,
	trig,
	trig1,
	trig2,
	pwm_out1,
	pwm_out2,
	pwm_out3,
	pwm_out4,
	pwm_out5);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst_n;
	input trig;
	input trig1;
	input trig2;
	output pwm_out1;
	output pwm_out2;
	output pwm_out3;
	output pwm_out4;
	output pwm_out5;

	wire clk;
	wire rst_n;
	wire trig;
	wire trig1;
	wire trig2;
	wire pwm_out1;
	wire pwm_out2;
	wire pwm_out3;
	wire pwm_out4;
	wire pwm_out5;
	wire control_pwm6_start;
	wire control_pwm7_start;
	wire control_pwm8_start;

	//----Code starts here: integrated by Robei-----
	wire start;
		wire start1;
		wire start2;
		wire finish;
		
	pwm 
	/* #(
	   .WAIT1 (64'd500_000_000)   ,  		//2s 500_000_000	 
	   .WAIT2 (64'd1000_000_000)             //4s 1000_000_000
	)  */u_pwm1(
		.clk(clk),
		.rst_n(rst_n),
		.pwm_out(pwm_out1),
		.s_da_in1(4'd3),
		.s_da_in2(4'd4), 
		.start(start),
		.start1(start1),
		.start2(start2),
		.finish(finish)
		);
	pwm 
	/* #(
	   .WAIT1 (64'd500_000_000)   ,  		//2s 500_000_000	 
	   .WAIT2 (64'd1000_000_000)             //4s 1000_000_000
	)  */u_pwm2(
		.clk(clk),
		.rst_n(rst_n),
		.pwm_out(pwm_out2),
		.s_da_in1(4'd2),
		.s_da_in2(4'd1), 
		.start(start),
		.start1(start1),
		.start2(start2),
		.finish(finish)
		);
		pwm 
	/* #(
	   .WAIT1 (64'd500_000_000)   ,  		//2s 500_000_000	 
	   .WAIT2 (64'd1000_000_000)             //4s 1000_000_000
	)  */u_pwm3(
		.clk(clk),
		.rst_n(rst_n),
		.pwm_out(pwm_out3),
		.s_da_in1(4'd3),
		.s_da_in2(4'd4), 
		.start(start),
		.start1(start1),
		.start2(start2),
		.finish(finish)
		);
		pwm 
	/* #(
	   .WAIT1 (64'd500_000_000)   ,  		//2s 500_000_000	 
	   .WAIT2 (64'd1000_000_000)             //4s 1000_000_000
	)  */u_pwm4(
		.clk(clk),
		.rst_n(rst_n),
		.pwm_out(pwm_out4),
		.s_da_in1(4'd2),
		.s_da_in2(4'd1), 
		.start(start),
		.start1(start1),
		.start2(start2),
		.finish(finish)
		);
			pwm 
	/* #(
	   .WAIT1 (64'd500_000_000)   ,  		//2s 500_000_000	 
	   .WAIT2 (64'd1000_000_000)             //4s 1000_000_000
	)  */u_pwm5(
		.clk(clk),
		.rst_n(rst_n),
		.pwm_out(pwm_out5),
		.s_da_in1(4'd2),
		.s_da_in2(4'd2), 
		.start(start),
		.start1(start1),
		.start2(start2),
		.finish(finish)
		);
	control_pwm  u_control1_pwm (
		.clk(clk),
		.rst(rst_n),
		.start(start),
		.trig(trig)
	    );
	control_pwm  u_control2_pwm (
		.clk(clk),
		.rst(rst_n),
		.start(start1),
		.trig(trig1)
	    );
	control_pwm  u_control3_pwm (
		.clk(clk),
		.rst(rst_n),
		.start(start2),
		.trig(trig2)
	    );
	assign finish = !trig;
	
	
	
	
	//---Module instantiation---
	pwm pwm1(
		.start(control_pwm6_start),
		.start1(control_pwm7_start),
		.start2(control_pwm8_start),
		.clk(clk),
		.rst_n(rst_n),
		.pwm_out(pwm_out1));

	pwm pwm2(
		.start(control_pwm6_start),
		.start1(control_pwm7_start),
		.start2(control_pwm8_start),
		.clk(clk),
		.rst_n(rst_n),
		.pwm_out(pwm_out2));

	pwm pwm3(
		.start(control_pwm6_start),
		.start1(control_pwm7_start),
		.start2(control_pwm8_start),
		.clk(clk),
		.rst_n(rst_n),
		.pwm_out(pwm_out3));

	pwm pwm4(
		.start(control_pwm6_start),
		.start1(control_pwm7_start),
		.start2(control_pwm8_start),
		.clk(clk),
		.rst_n(rst_n),
		.pwm_out(pwm_out4));

	pwm pwm5(
		.start(control_pwm6_start),
		.start1(control_pwm7_start),
		.start2(control_pwm8_start),
		.clk(clk),
		.rst_n(rst_n),
		.pwm_out(pwm_out5));

	control_pwm control_pwm6(
		.trig(trig),
		.clk(clk),
		.rst(rst_n),
		.start(control_pwm6_start));

	control_pwm control_pwm7(
		.trig(trig2),
		.clk(clk),
		.start(control_pwm7_start));

	control_pwm control_pwm8(
		.trig(trig1),
		.clk(clk),
		.rst(rst_n),
		.start(control_pwm8_start));

endmodule    //top_pwm_5

