module uart_tx(
	clk,
	rst,
	data_byte,
	start,
	tx_rs232,
	done);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst;
	input [7:0] data_byte;
	input start;
	output tx_rs232;
	output done;

	wire clk;
	wire rst;
	wire [7:0] data_byte;
	wire start;
	reg tx_rs232;
	reg done;

	//----Code starts here: integrated by Robei-----
	reg [7:0]r_data;
		always@(posedge clk or negedge rst)
		begin
			if(!rst)
				r_data <= 0;
			else if(start)
				r_data <= data_byte;
			else
				r_data <= r_data;
		end
		reg state;
		//====================state================//ģʽ
		always@(posedge clk or negedge rst)
		begin
			if(!rst)
				state <= 0;
			else if(start)
				state <= 1;
			else if(done)
				state <= 0;
			else
				state <= state;
		end
		
		//========================tx_cnt===================//
		reg [15:0]tx_cnt;
		always@(posedge clk or negedge rst)
		begin
			if(!rst)
				tx_cnt <= 0;
			else if(state)
			begin
				if(tx_cnt == 16'd5027)
					tx_cnt <= 0;
				else
					tx_cnt <= tx_cnt + 1;
			end
			else
				tx_cnt <= 0;
		end
		//========================tx_flag=================//
		reg tx_flag;
		always@(posedge clk or negedge rst)
		begin
			if(!rst)
				tx_flag <= 0;
			else if(tx_cnt == 1)
				tx_flag <= 1;
			else
				tx_flag <= 0;
		end
		//======================tx_number=================//
		reg [4:0]tx_number;
		always@(posedge clk or negedge rst)
		begin
			if(!rst)
				tx_number <= 0;
			else if(tx_flag)
				tx_number <= tx_number + 1;
			else if(tx_number == 5'd11)
				tx_number <= 0;
		end
		
		always@(posedge clk or negedge rst)
		begin
			if(!rst)
				tx_rs232 <= 1;
			else if(tx_flag)
				begin
					case(tx_number)
						0:tx_rs232 <= 1;
						1:tx_rs232 <= 0;
						5'd2:tx_rs232 <= r_data[0];
						5'd3:tx_rs232 <= r_data[1];
						5'd4:tx_rs232 <= r_data[2];
						5'd5:tx_rs232 <= r_data[3];
						5'd6:tx_rs232 <= r_data[4];
						5'd7:tx_rs232 <= r_data[5];
						5'd8:tx_rs232 <= r_data[6];
						5'd9:tx_rs232 <= r_data[7];
						5'd10:tx_rs232 <= 1;
						default:tx_rs232 <= 1;
					endcase
					
				end
		end
		//=====================done====================//
		always@(posedge clk or negedge rst)
		begin
			if(!rst)
				done <= 0;
			else if(tx_number == 5'd11)
				done <= 1;
			else
				done <= 0;
		end
		
	
	
	
endmodule    //uart_tx

